sets
t  Conjunto de tiempos      /t1*t48/
i  Conjunto de nodos        /N1*N21/
g  Conjunto de generadores  /G1/
gd Conjunto de gen. disy.   /GD1*GD3/
b  Conjunto de baterias     /B1*B3/
map(g,i)  Asocia nodos y generadores /G1.N1/
mapgd(gd,i)  Asocia nodos y generadores /GD1.N12,GD2.N21/
mapb(b,i)  Asocia nodos y generadores /B1.N7,B2.N10,B3.N15/;

Scalars
kpvwt Constante de proporcion de la generacion  /2.0/
sbase Potencia base para el colculo del costo   /1000/
Dt Delta de tiempo considerado                  /0.5/;

alias(i,j);

Table Gbus(i,j)
    N1                       N2                      N3                       N4                      N5                      N6                       N7                       N8                       N9                       N10                      N11                      N12                      N13                      N14                      N15                      N16                      N17                      N18                      N19                      N20                      N21
N1  373.864430468204        -188.679245283019        -185.185185185185        0                       0                       0                        0                        0                        0                        0                        0                        0                        0                        0                        0                        0                        0                        0                        0                        0                        0
N2  -188.679245283019        188.679245283019        0                        0                       0                       0                        0                        0                        0                        0                        0                        0                        0                        0                        0                        0                        0                        0                        0                        0                        0
N3  -185.185185185185        0                       829.319885923660         -185.185185185185       0                       0                        -270.270270270270        0                        0                        -188.679245283019        0                        0                        0                        0                        0                        0                        0                        0                        0                        0                        0
N4  0                        0                       -185.185185185185        539.993775287893        -158.730158730159       -196.078431372549        0                        0                        0                        0                        0                        0                        0                        0                        0                        0                        0                        0                        0                        0                        0
N5  0                        0                       0                        -158.730158730159       158.730158730159        0                        0                        0                        0                        0                        0                        0                        0                        0                        0                        0                        0                        0                        0                        0                        0
N6  0                        0                       0                        -196.078431372549       0                       196.078431372549         0                        0                        0                        0                        0                        0                        0                        0                        0                        0                        0                        0                        0                        0                        0
N7  0                        0                       -270.270270270270        0                       0                       0                        535.741437640172        -126.582278481013         -138.888888888889        0                        0                        0                        0                        0                        0                        0                        0                        0                        0                        0                        0
N8  0                        0                       0                        0                       0                       0                        -126.582278481013        126.582278481013         0                        0                        0                        0                        0                        0                        0                        0                        0                        0                        0                        0                        0
N9  0                        0                       0                        0                       0                       0                        -138.888888888889        0                        138.888888888889         0                        0                        0                        0                        0                        0                        0                        0                        0                        0                        0                        0
N10 0                        0                       -188.679245283019        0                       0                       0                        0                        0                        0                        572.319067730704         -263.157894736842        0                        0                        -120.481927710843        0                        0                        0                        0                        0                        0                        0
N11 0                        0                       0                        0                       0                       0                        0                        0                        0                        -263.157894736842        517.945301422983         -126.582278481013        -128.205128205128        0                        0                        0                        0                        0                        0                        0                        0
N12 0                        0                       0                        0                       0                       0                        0                        0                        0                        0                        -126.582278481013        126.582278481013         0                        0                        0                        0                        0                        0                        0                        0                        0
N13 0                        0                       0                        0                       0                       0                        0                        0                        0                        0                        -128.205128205128        0                        128.205128205128         0                        0                        0                        0                        0                        0                        0                        0
N14 0                        0                       0                        0                       0                       0                        0                        0                        0                        -120.481927710843        0                        0                        0                        402.533209762125         -153.846153846154        0                        0                        0                        -128.205128205128        0                        0
N15 0                        0                       0                        0                       0                       0                        0                        0                        0                        0                        0                        0                        0                        -153.846153846154        310.096153846154         -156.250000000000        0                        0                        0                        0                        0
N16 0                        0                       0                        0                       0                       0                        0                        0                        0                        0                        0                        0                        0                        0                        -156.250000000000        414.841925258592         -135.135135135135        -123.456790123457        0                        0                        0
N17 0                        0                       0                        0                       0                       0                        0                        0                        0                        0                        0                        0                        0                        0                        0                        -135.135135135135        135.135135135135         0                        0                        0                        0
N18 0                        0                       0                        0                       0                       0                        0                        0                        0                        0                        0                        0                        0                        0                        0                        -123.456790123457        0                        123.456790123457         0                        0                        0
N19 0                        0                       0                        0                       0                       0                        0                        0                        0                        0                        0                        0                        0                        -128.205128205128        0                        0                        0                        0                        369.203966764942        -119.047619047619        -121.951219512195
N20 0                        0                       0                        0                       0                       0                        0                        0                        0                        0                        0                        0                        0                        0                        0                        0                        0                        0                        -119.047619047619        119.047619047619        0
N21 0                        0                       0                        0                       0                       0                        0                        0                        0                        0                        0                        0                        0                        0                        0                        0                        0                        0                        -121.951219512195        0                        121.951219512195;

Table Load(i,*)
    PL
N1  0.00
N2  0.25
N3  0.00
N4  0.00
N5  0.04
N6  0.14
N7  0.00
N8  0.13
N9  0.32
N10 0.00
N11 0.17
N12 0.00
N13 0.31
N14 0.00
N15 0.00
N16 0.00
N17 0.17
N18 0.13
N19 0.04
N20 0.10
N21 0.00
;
Table CV(t,*)
      Cost   Var
t1    0.770  0.17
t2    0.740  0.14
t3    0.710  0.11
t4    0.700  0.11
t5    0.690  0.11
t6    0.695  0.10
t7    0.700  0.09
t8    0.710  0.09
t9    0.720  0.09
t10   0.760  0.10
t11   0.800  0.11
t12   0.835  0.13
t13   0.870  0.14
t14   0.890  0.17
t15   0.910  0.20
t16   0.895  0.25
t17   0.880  0.31
t18   0.895  0.34
t19   0.910  0.36
t20   0.910  0.39
t21   0.910  0.42
t22   0.910  0.43
t23   0.910  0.45
t24   0.905  0.46
t25   0.900  0.47
t26   0.900  0.47
t27   0.895  0.45
t28   0.890  0.42
t29   0.895  0.43
t30   0.900  0.45
t31   0.900  0.45
t32   0.900  0.45
t33   0.925  0.45
t34   0.950  0.45
t35   0.945  0.45
t36   0.940  0.45
t37   0.925  0.43
t38   0.910  0.42
t39   0.905  0.46
t40   0.900  0.50
t41   0.875  0.49
t42   0.850  0.47
t43   0.825  0.45
t44   0.800  0.42
t45   0.755  0.38
t46   0.710  0.34
t47   0.685  0.29
t48   0.660  0.25
;
Table Gend(t,gd)
           GD1                GD2
t1         0                  0.245873253
t2         0                  0.238092272
t3         0                  0.234141469
t4         0                  0.228223007
t5         0                  0.226160799
t6         0                  0.223852255
t7         0                  0.220296564
t8         0                  0.219533935
t9         0                  0.221217261
t10        0                  0.223744417
t11        0                  0.231474735
t12        0                  0.242550753
t13        0                  0.271053369
t14        0.000081000        0.300394318
t15        0.015143791        0.329437578
t16        0.064797891        0.367459308
t17        0.133650506        0.366208180
t18        0.277594214        0.379621854
t19        0.370042423        0.389229299
t20        0.442579040        0.382997210
t21        0.462916140        0.383637404
t22        0.613533499        0.377030070
t23        0.688283637        0.372531964
t24        0.792836979        0.364206150
t25        0.715436295        0.366962010
t26        0.703404358        0.364826272
t27        0.768870567        0.367061246
t28        0.650115434        0.364937549
t29        0.630503113        0.365180669
t30        0.675145649        0.363392096
t31        0.515045467        0.363111770
t32        0.489464819        0.355664886
t33        0.277192085        0.347458294
t34        0.241427141        0.334989202
t35        0.160733539        0.323291418
t36        0.093251046        0.311530981
t37        0.036847221        0.272464139
t38        0.003540126        0.234860551
t39        0                  0.249833030
t40        0                  0.254501754
t41        0                  0.234699004
t42        0                  0.227555545
t43        0                  0.203231133
t44        0                  0.173651304
t45        0                  0.159817635
t46        0                  0.144329775
t47        0                  0.142039886
t48        0                  0.147818295
;
TABLE Baterias(b,*)   Rango de operacion de las baterias
      SoCmin  SoCmax  SoCini SoCfin Phi     PbD          PbC
*     [%]     [%]     [%]     [%]
B1    0.0     1       0.0    0.0    0.8     0.3125      -0.25
B2    0.0     1       0.0    0.0    1.0     0.2500      -0.20
B3    0.0     1       0.0    0.0    1.0     0.2500      -0.20
;


Variables
z Funcion objetivo
v(i,t)    Voltajes en todos los nodos
p(g,t)    Potencias generadas
pgd(gd,t) Potencias generacion distribuida
SoC(b,t)  Estado de carga de la bateria
pb(b,t)   Potencias de las baterias
;
pgd.lo(gd,t) = 0;                   pgd.up(gd,t) = kpvwt*Gend(t,gd);
pb.lo(b,t) = Baterias(b,'PbC');     pb.up(b,t) =   Baterias(b,'PbD');
SoC.lo(b,t) = Baterias(b,'SoCmin'); SoC.up(b,t) =  Baterias(b,'SoCmax');
*SoC.fx(b,'t1') =  Baterias(b,'SoCini');
SoC.fx(b,'t48') = Baterias(b,'SoCfin');
v.lo(i,t) = 0.95;                   v.up(i,t) = 1.05;
v.fx('N1',t) = 1.0;
p.lo(g,t) = 0;

Equations

Fo  Funcion objetivo
Balance(i,t) Balance de potencias
Estados(b,t) Estado de carga de la bateria
;

Fo.. z =e= sbase*sum(g,sum(t,CV(t,'Cost')*p(g,t)))*Dt;

Balance(i,t)..  sum(g$map(g,i),p(g,t)) + sum(gd$mapgd(gd,i),pgd(gd,t)) + 0*sum(b$mapb(b,i),pb(b,t)) - 2*Load(i,'PL')*CV(t,'Var') =e= sum(j,Gbus(i,j)*(v(i,t) + v(j,t) - 1));

Estados(b,t)..  SoC(b,t) =e= SoC(b,t-1)$(ord(t) gt 1) + Baterias(b,'SoCini')$(ord(t) eq 1) - Baterias(b,'Phi')*Pb(b,t);


Model   Stability /all/;
option limrow = 200000;
option iterlim = 200000;
solve   Stability using NLP minimizing z;
display v.l,pb.l,SoC.l,z.l;
